macroScript Collect_asset
	category:"# Scripts"
	toolTip:"Collect Aasset"
	Icon:#("TrackBar",2)
(
	title = "Collect Aasset v1.55"
	--This script created by Morozov Anton
	-- Collect all textures and others external files in one folder.
try (destroyDialog ::Collect_asset) catch()
try (destroyDialog ::match_bmp) catch()
local pic_1 = pic_2 = ""
local errors = copied = 0
local exitt = false
GLOBAL_INI_FILENAME = "collect_asset.ini"
GLOBAL_INI_FILE_PATH = ((getdir #userScripts) + "\\Collect_asset\\")
GLOBAL_7Z_PATH = (GLOBAL_INI_FILE_PATH + "7z\\")

--function to load variable from ini file
fn loadVarFromIniFile section_name var_name = 
(
	local INIFilename = ""
	local temp_value = ""
	INIFilename = pathConfig.appendPath GLOBAL_INI_FILE_PATH GLOBAL_INI_FILENAME
	temp_value = getINISetting INIFilename section_name var_name
	if temp_value == "" then undefined else temp_value
)


function getAssetFiles = (
	ff_fnd=#(); ff_ok=#(); ff_mis=#();
	ATSOps.CheckNetworkPaths = true
	ATSOps.Refresh()
	ATSOps.GetFiles &ff
	if maxFileName != "" then	deleteItem ff 1
	for i = ff.count to 1 by -1 do (
		if (ATSOps.IsInputFile ff[i]) == false then
			deleteItem ff i
		else (
			ss = ATSOps.GetFileSystemStatus ff[i]
			if  ss[1] == #found do append ff_fnd ff[i]
			if  ss[1] == #ok do append ff_ok ff[i]
			if  ss[1] == #missing do append ff_mis ff[i]
		)
	)
	#(ff, ff_fnd, ff_ok, ff_mis)
)

function statusrfr = (
	tt = getAssetFiles();
	fnd = tt[2].count
	okk = tt[3].count
	mis = tt[4].count
	Collect_asset.status.caption = "Ok - "+ okk as string +", Found - "+ fnd as string +", Missing - "+ mis as string
)

function ResolvePaths = (
	ATSOps.Visible = false
	tt = getAssetFiles(); ff = tt[1]
	for i=1 to 2 do (		
		for i = 1 to ff.count while not exitt do (
			ss = ATSOps.GetFileSystemStatus ff[i]
			if  ss[1] == #found do (
				ATSOps.GetResolvedPaths ff[i] &resPath
				ATSOps.SelectFiles ff[i]
				ATSOps.SetPathOnSelection (getFilenamePath resPath[1])
				print resPath[1]
			)
			precents = 1000/(ff.count*10 / i)
			Collect_asset.pb1.value = precents
			if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages() --yoi ?oia iaen ia caaenae
			if  (keyboard.EscPressed) and (queryBox "you want to abort operation?") then return ()
		)
	)
	print "ResolvePaths end work"
	Collect_asset.pb1.value = 0
)

function DelMissing = (
	ATSOps.Visible = false
	tt = getAssetFiles(); ff = tt[1]
	for i=1 to 2 do (		
		for i = 1 to ff.count while not exitt do (
			ss = ATSOps.GetFileSystemStatus ff[i]
			if  ss[1] == #Missing do (
				ATSOps.SelectFiles ff[i]
				ATSOps.RetargetSelection ""
			)
			precents = 1000/(ff.count*10 / i)
			Collect_asset.pb1.value = precents
			if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages() --yoi ?oia iaen ia caaenae
			if  (keyboard.EscPressed) and (queryBox "you want to abort operation?") then return ()
		)
	)
	print "Missing paths deleted"
	Collect_asset.pb1.value = 0
)

function chDir dirpath = (
	if (doesFileExist dirpath) == false then (
		if queryBox("Directory does not exist. Create a Directory?") then
			if (makeDir dirpath all:true) then
				return true
			else messagebox "Can not create directory" title:"Error"
	) else (
		local str = dirpath
		if dirpath.count > 1 do if (substring dirpath (dirpath.count - 1) 2) != ":\\" do str = trimRight dirpath "\\\/"
		if isDirectoryWriteable(str) then
			return true
		else messagebox "Directory not writeable" title:"Error"
	)
	return false
)

function create_Dir dirpath = (
	local err = true
	if (doesFileExist dirpath) == true then 
		(
			HiddenDOSCommand ("rmdir /S /Q "+dirpath) exitCode:&exitcode
			if exitcode != 0 then ( print ("EROR delete dir " + dirpath); err = false;)
		)
	if (doesFileExist dirpath) == false then 
		if (makeDir dirpath all:true) == false then (print ("EROR create dir " + dirpath); err = false;)
	err
)

function enableCtrl ctrl = (
	if ctrl then 
		for c in Collect_asset.controls where (classof c != ProgressBar) do c.enabled = true
	else
		for c in Collect_asset.controls where (classof c != ProgressBar) do c.enabled = false
)

function dim_x bmpin = (
	if bmpin.width >= bmpin.height then
		330
	else
		330*(bmpin.width*100 / bmpin.height)/100
)
function dim_y bmpin = (
	if bmpin.width <= bmpin.height then
		330
	else
		330*(bmpin.height*100 / bmpin.width)/100
)

function chk_path str = (
	str = trimleft str
	str = trimRight str
	str = trimRight str "\\\/"
	str + "\\"
)

function collect_as dirpath selected relink= (
	if chDir(dirpath) then (
				ff_npath = #()
				ATSOps.Visible = false
				tt = getAssetFiles();
				ATSOps.SelectFiles tt[2]
				ATSOps.SetPathOnSelection ""
				--tt = getAssetFiles(); ff = tt[1]
				if selected then  (
					ff = #()
					for obj in selection do join ff (usedMaps obj)
					ff = makeUniqueArray ff
				) else (
					ff = usedMaps()
					ff = makeUniqueArray ff
				)
				newPath = dirpath
				errors = copied = 0
				for i = 1 to ff.count while not exitt do (
					ss = ATSOps.GetFileSystemStatus ff[i]
					oldfullpath = ff[i]
					newfullpath = newPath + filenameFromPath ff[i]
					if newfullpath != undefined do (
						if doesFileExist(newfullpath) == false then (
							if (copyFile oldfullpath newfullpath) then (
								append ff_npath ff[i]
								copied = copied+1
								print newfullpath
							) else errors = errors+1
						)
						else (
							if (getFileSize(oldfullpath) != getFileSize(newfullpath)) then (
								if relink then (
									pic_1 = oldfullpath
									pic_2 = newfullpath
									createDialog match_bmp modal:true
								) else (
									messagebox "Found different files with the same name. Fix this by using the parameter \"and relink to selected directory\". Operation aborted." title:"Error"
									exitt = true
								)
							) else (
								append ff_npath ff[i]
							)
						)
					)
					precents = 1000/(ff.count*10 / i)
					Collect_asset.pb1.value = precents
					if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages() 
					if  (keyboard.EscPressed) and (queryBox "you want to abort operation?") then return ()
				)
				if relink then (
					ATSOps.SelectFiles ff_npath
					ATSOps.SetPathOnSelection newPath
				)
				print "Collect Asset end work"
				Collect_asset.pb1.value = 0
				#(copied, errors)
			)
)

rollout match_bmp "Match bitmaps" width:840 height:520
(
	bitmap bmp_1 "Bitmap" pos:[16,32] width:330 height:330
	bitmap bmp_2 "Bitmap" pos:[488,32] width:330 height:330
	label lbl_bmp1 ":" pos:[17,372] width:329 height:107
	label lbl_bmp2 ":" pos:[488,375] width:329 height:104
	label lbl3 "Bitmap now assigned" pos:[16,16] width:328 height:16
	label lbl4 "Exist Bitmap in new path" pos:[488,16] width:328 height:16
	button btn_rplc ">> Replace >>" pos:[355,174] width:123 height:27
	button btn_exist "Use Exist Bitmap >>" pos:[355,217] width:123 height:27
	button btn_rnm "Rename" pos:[480,488] width:123 height:27
	edittext edt_new_name "New name" pos:[16,494] width:456 height:16
	button btn_nothing "Do nothing" pos:[696,488] width:123 height:27 toolTip:"leave the current path"
	on match_bmp open do
	(
			tmp_bmp2 = openBitMap pic_1
			tmp_bmp1 = bitmap (dim_x tmp_bmp2) (dim_y tmp_bmp2)
			copy tmp_bmp2 tmp_bmp1
			match_bmp.lbl_bmp1.caption = pic_1 + "\n dimension: " + tmp_bmp2.width as string + "x" + tmp_bmp2.height as string + "\n file size: " + getFileSize(pic_1) as string + "\n file date: " + getFileModDate(pic_1)
			close tmp_bmp2
			match_bmp.bmp_1.bitmap = tmp_bmp1
			tmp_bmp2 = openBitMap pic_2
			tmp_bmp1 = bitmap (dim_x tmp_bmp2) (dim_y tmp_bmp2)
			copy tmp_bmp2 tmp_bmp1
			close tmp_bmp2
			match_bmp.bmp_2.bitmap = tmp_bmp1
			match_bmp.lbl_bmp2.caption = pic_2 + "\n dimension: " + tmp_bmp2.width as string + "x" + tmp_bmp2.height as string + "\n file size: " + getFileSize(pic_2) as string + "\n file date: " + getFileModDate(pic_2)
			match_bmp.edt_new_name.text = getFilenameFile pic_1 + "_1"
		)
	on btn_rplc pressed do
	(
			if (deleteFile pic_2) and (copyFile pic_1 pic_2) then (
				ATSOps.SelectFiles pic_1
				ATSOps.SetPathOnSelection (getFilenamePath pic_2)
				DestroyDialog match_bmp
			)
			else messagebox "Can not replace the file. Check access" title:"Error"
		)
	on btn_exist pressed do
	(
			ATSOps.SelectFiles pic_1
			ATSOps.SetPathOnSelection (getFilenamePath pic_2)
			DestroyDialog match_bmp
		)
	on btn_rnm pressed do
	(
			rnmfullpath = getFilenamePath pic_2 + match_bmp.edt_new_name.text + getFilenameType pic_2
			if doesFileExist(rnmfullpath) == false then (
				if (copyFile pic_1 rnmfullpath) then (
					ATSOps.SelectFiles pic_1
					ATSOps.RetargetSelection rnmfullpath
					copied = copied+1
					print rnmfullpath
					DestroyDialog match_bmp
				) else messagebox "Can not save the file. Check access" title:"Error"
				
			) else messagebox "File alrady exist. Try other file name"
			
		)
	on btn_nothing pressed do
		DestroyDialog match_bmp
)

rollout Collect_asset title width:456 height:432
(
	button btn1 "Resolve paths" pos:[16,64] width:96 height:32
	button open_btn "Select" pos:[344,184] width:82 height:24
	edittext dir_edt "" pos:[24,184] width:312 height:23
	label dir_lbl "Selected Directory" pos:[32,167] width:131 height:14
	button btn_collect "Collect Files" pos:[32,216] width:96 height:56
	label lbl11 "- Changes the status of files in Asset Tracking from 'found' to 'ok'" pos:[120,64] width:208 height:34
	label lbl14 "- Collect all assets to the Selected Directory" pos:[136,218] width:300 height:17
	label lbl15 "Status:" pos:[16,16] width:40 height:16
	label status ":" pos:[64,16] width:320 height:16
	button btn_stat_refr "Refresh" pos:[392,16] width:48 height:16 toolTip:"Refresh status"
	button btn_ATopen "Asset Tracking" pos:[344,40] width:96 height:16 toolTip:"Open Asset Tracking"
	button btn_setPath "Set Path" pos:[32,280] width:96 height:32
	label lbl27 "- Change paths of all files in Asset Tracking to Selected Directory" pos:[136,280] width:208 height:40
	progressBar pb1 "ProgressBar" pos:[18,414] width:421 height:8
	checkbox chk_rlnk "and relink to selected directory" pos:[144,236] width:179 height:18 checked:true
	button btn_delmissing "Del Missing Paths" pos:[16,106] width:96 height:32
	label lbl7 "- Delete missing paths" pos:[120,106] width:208 height:34
	checkbox chk_sel "only from selected objects" pos:[144,253] width:179 height:18 enabled:true checked:false
	button btn_archive "Make Archive" pos:[16,368] width:96 height:32
	checkbox arch_chk_sel "only selected objects" pos:[128,368] width:179 height:18 enabled:true checked:false
	groupBox grp1 "Operations with Directory" pos:[16,146] width:424 height:214
	button btn_rnm_russian "Rename Russian" pos:[32,320] width:96 height:32
	label lbl8 "- Rename russin symbols and copy to Selected Directory" pos:[136,320] width:300 height:17
	on Collect_asset open do
	(
			Collect_asset.dir_edt.text = maxFilePath
			statusrfr()
		)
	on Collect_asset close do
		exitt = true
	on btn1 pressed do
	(
		exitt = false
		enableCtrl false
		ResolvePaths ()
		statusrfr()
		enableCtrl true
		)
	on open_btn pressed do
	(
			s = getSavePath caption:"Select Dir" initialDir:Collect_asset.dir_edt.text
			if s != undefined then dir_edt.text = chk_path s
		)
	on dir_edt entered txt do
		dir_edt.text = chk_path dir_edt.text
	on btn_collect pressed do
	(
		exitt = false
		enableCtrl false
		tmp = collect_as dir_edt.text chk_sel.checked chk_rlnk.checked
		messagebox ("Copied "+tmp[1] as string + " files. Errors " + tmp[2] as string)
		statusrfr()
		enableCtrl true
		)
	on btn_stat_refr pressed do
	(
		statusrfr()
	)
	on btn_ATopen pressed do
	(
			ATSOps.Visible = true
		)
	on btn_setPath pressed do
	(
		exitt = false
		enableCtrl false
		--if chDir(Collect_asset.dir_edt.text) then (
			ATSOps.Visible = false
			tt = getAssetFiles(); ff = tt[1]
			ATSOps.SelectFiles ff
			ATSOps.SetPathOnSelection Collect_asset.dir_edt.text
			tt = getAssetFiles(); ff = tt[1]
			lost = #()
			for i=1 to ff.count do (
				if  getFilenamePath(ff[i]) != Collect_asset.dir_edt.text do append lost ff[i]
			)
			if lost.count >0 then (
				ATSOps.SelectFiles lost
				ATSOps.SetPathOnSelection Collect_asset.dir_edt.text
			)
		--)
		statusrfr()
		enableCtrl true
	)
	on btn_delmissing pressed do
	(
		exitt = false
		enableCtrl false
		if queryBox "Are you sure you want to delete missing paths?" do DelMissing()
		statusrfr()
		enableCtrl true
		)
	on btn_archive pressed do
	(
		exitt = false
		if arch_chk_sel.checked and selection.count == 0 then (
			messagebox "nothing is selected" title:"Error"
			return()
		)
		enableCtrl false
		local err = false
		TEMP_DIR = sysInfo.tempdir + "collect_asset_tmp\\"
		ASSETS_DIR = TEMP_DIR+"maps\\"
		if not (create_Dir TEMP_DIR) then err = true
		if not (create_Dir ASSETS_DIR) then err = true
		if maxFileName != "" then scenename = maxFileName else scenename = "scene.max"
		tmp = collect_as ASSETS_DIR arch_chk_sel.checked false
		if exitt do err = true
		if tmp[2] != 0 then err = true
		if arch_chk_sel.checked then (
			scenename = getSaveFileName caption:"Enter name of max file" \
			filename:(maxFilePath) \
			types:"3ds max (*.max)|*.max"
			if scenename != undefined then (
				scenename = filenameFromPath scenename
				if (saveNodes selection (TEMP_DIR+scenename)) == false then err = true
			) else ( messagebox "Operation Aborted" title:"Error"; err = true)
		) else if (saveMaxFile (TEMP_DIR+scenename) clearNeedSaveFlag:false useNewFile:false) == false then err = true
		if err do print "ERROR"
		if not err then (
			archive_file = getSaveFileName caption:"Select name of archive" \
			filename:(maxFilePath + (getFilenameFile scenename)) \
			types:"7-zip (*.7z)|*.7z|Zip (*.zip)|*.zip"
			if archive_file != undefined then (
				if (doesFileExist archive_file) == true then deleteFile archive_file
				if getFilenameType(archive_file) == ".7z" do HiddenDOSCommand ("7zG.exe a \""+archive_file+"\" -r \""+TEMP_DIR+"*\" -m0=LZMA2 -ssw") startpath:GLOBAL_7Z_PATH
				if getFilenameType(archive_file) == ".zip" do HiddenDOSCommand ("7zG.exe a \""+archive_file+"\" -r \""+TEMP_DIR+"*\" -ssw") startpath:GLOBAL_7Z_PATH
			) else messagebox "Operation Aborted" title:"Error"
		) else messagebox "Error save to Temp folder" title:"Error"
		HiddenDOSCommand ("rmdir /S /Q "+TEMP_DIR)
		if not err then messagebox "Creating an archive completed" title:"Completed"
		enableCtrl true
	)
	on btn_rnm_russian pressed do
	(
		local f = k = 0
		exitt = false
		enableCtrl false
		if chDir(dir_edt.text) then (
				russ = ""
				if  (temp_state = loadVarFromIniFile "symbols" "russ") != undefined then
				(
					russ = temp_state as string
				)
				else
				(
					messagebox ("Error load variable russ")
					return()
				)
				enn = ""
				if  (temp_state = loadVarFromIniFile "symbols" "enn") != undefined then
				(
					enn = temp_state as string
				)
				else
				(
					messagebox ("Error load variable enn")
					return()
				)
				ff_npath = #()
				ATSOps.Visible = false
				tt = getAssetFiles(); ff = tt[1]
				ATSOps.SelectFiles tt[2]
				ATSOps.SetPathOnSelection ""
				tt = getAssetFiles(); ff = tt[1]
				newPath = dir_edt.text
				ennsmb = filterString enn ","
				russsmb = filterString russ ","
				for i = 1 to ff.count while not exitt do (
					namefile = getFilenameFile ff[i]
					rusfnd = false
					rename = ""
					fnd = 0
					ss = ATSOps.GetFileSystemStatus ff[i]
					if  (ss[1] == #ok) or (ss[1] == #found) do (
						for j = 1 to namefile.count do (
							fnd = findItem russsmb namefile[j]
							if fnd > 0 then (
								append rename ennsmb[fnd]
								rusfnd = true
							)
							else append rename namefile[j]
						)
					)
					if rusfnd do (
						newfullpath = undefined
						if  (ss[1] == #ok)  do (
							newfullpath = newPath + rename + getFilenameType ff[i]
							oldfullpath = ff[i]
						)
						if  (ss[1] == #found) do (
							ATSOps.GetResolvedPaths ff[i] &resPath
							oldfullpath = resPath[1]
							newfullpath = newPath + rename + getFilenameType ff[i]
						)
						if newfullpath != undefined do (
							while doesFileExist(newfullpath) do newfullpath = getFilenamePath (newfullpath) + getFilenameFile (newfullpath) + "1" + getFilenameType (newfullpath)
								if (copyFile oldfullpath newfullpath) then (
									ATSOps.SelectFiles ff[i]
									ATSOps.RetargetSelection newfullpath
									k = k+1
									print newfullpath
								) else f = f+1
						)
					)
					precents = 1000/(ff.count*10 / i)
					pb1.value = precents
					if (((maxVersion())[1] / 1000) >= 13) do windows.processPostedMessages() --    
					if exitt then return()
				)
				messagebox ("Copied "+k as string + " files. Errors " + f as string)
				Collect_asset.pb1.value = 0
			)
		statusrfr()
		enableCtrl true
	)
)
ATSOps.Visible = true
createDialog Collect_asset
ATSOps.Visible = false
)

messageBox "Collect Asset is now installed!\n\nTo run it goto:\n   Customize -> Customize User Interface -> Toolbars\nCategory: \"# Scripts\" and drag \"Collect Asset\" to a toolbar.\n\nClick the toolbar icon to run it!"
